"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function wrapType(type) {
    if (type.startsWith('{') &&
        type.endsWith('}') &&
        type.indexOf('{', 1) === -1 &&
        type.indexOf('}') === type.length - 1) {
        // has one and only one bracket
        return type;
    }
    if (type.startsWith('(') && type.endsWith(')')) {
        // already wrapped
        return type;
    }
    return "(" + type + ")";
}
exports.wrapType = wrapType;
function biOpType(op, aType, bType) {
    if (aType === '{}') {
        return bType;
    }
    if (bType === '{}') {
        return aType;
    }
    return wrapType(aType) + (" " + op + " ") + wrapType(bType);
}
exports.biOpType = biOpType;
function andType(aType, bType) {
    return biOpType('&', aType, bType);
}
exports.andType = andType;
function orType(aType, bType) {
    return biOpType('|', aType, bType);
}
exports.orType = orType;
//# sourceMappingURL=compose.js.map