"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parseBracket(s) {
    if (s[0] !== '(') {
        throw new Error("expect '(' for bracket group");
    }
    var start = 1;
    var end = s.indexOf(')', start);
    if (end === -1) {
        throw new Error("expect ')' for bracket group");
    }
    return s
        .substring(start, end)
        .split(',')
        .map(function (s) { return s.trim(); });
}
function parseFunction(func) {
    var s = func.toString();
    if (s.startsWith('function ') || s.startsWith('function(')) {
        var idx_1 = s.indexOf('(');
        if (idx_1 === -1) {
            throw new Error("expect '(' after 'function'");
        }
        s = s.substr(idx_1);
        return parseBracket(s);
    }
    if (s.startsWith('(')) {
        return parseBracket(s);
    }
    var idx = s.indexOf('=>');
    if (idx === -1) {
        throw new Error("expect '=>' after arrow function argument");
    }
    return [s.substring(0, idx).trim()];
}
function genFunctionType(func) {
    var args = parseFunction(func);
    return "(" + args.join(',') + ") => any";
}
exports.genFunctionType = genFunctionType;
//# sourceMappingURL=function-type.js.map