"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var map_1 = require("@beenotung/tslib/map");
/* name -> type */
var function_type_1 = require("./function-type");
var typeMap = new Map();
function setTsType(name, type) {
    typeMap.set(name, type);
}
exports.setTsType = setTsType;
/** will rename to genTsType in next major release */
function genTsType(o, options) {
    var e_1, _a, e_2, _b;
    if (options === void 0) { options = {}; }
    var type = typeof o;
    switch (type) {
        case 'function':
            return function_type_1.genFunctionType(o);
        case 'string':
            if (typeMap.has(o)) {
                return typeMap.get(o);
            }
            return type;
        case 'number':
        case 'boolean':
        case 'bigint':
        case 'symbol':
        case 'undefined':
            return type;
        case 'object':
            if (o instanceof Date) {
                return 'Date';
            }
            var currentIndent = options.currentIndent || '';
            var indentStep = options.indentStep || '  ';
            var innerIndent_1 = currentIndent + indentStep;
            var nextLevelOption_1 = __assign({}, options, { currentIndent: innerIndent_1 });
            if (Array.isArray(o)) {
                if (o.length < 1) {
                    if (options.allowEmptyArray) {
                        return 'any[]';
                    }
                    throw new TypeError('cannot determine type of empty array');
                }
                // least 1 element
                if (options.allowOptionalFieldInArray) {
                    var nonObjectTypes = new Set();
                    var fields = new Map();
                    var total_1 = 0;
                    try {
                        for (var o_1 = __values(o), o_1_1 = o_1.next(); !o_1_1.done; o_1_1 = o_1.next()) {
                            var x = o_1_1.value;
                            if (x &&
                                typeof x === 'object' &&
                                !(x instanceof Date) &&
                                !(x instanceof Map) &&
                                !(x instanceof Set)) {
                                // really object
                                total_1++;
                                try {
                                    for (var _c = __values(Object.entries(x)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                        var _e = __read(_d.value, 2), key = _e[0], value = _e[1];
                                        var type_1 = genTsType(value, options);
                                        var field = map_1.mapGetOrSetDefault(fields, key, function () { return ({
                                            types: new Set(),
                                            count: 0,
                                        }); });
                                        field.count++;
                                        field.types.add(type_1);
                                    }
                                }
                                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                                finally {
                                    try {
                                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                                    }
                                    finally { if (e_2) throw e_2.error; }
                                }
                            }
                            else {
                                // not object
                                nonObjectTypes.add(genTsType(x, options));
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (o_1_1 && !o_1_1.done && (_a = o_1.return)) _a.call(o_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    var res_1 = 'Array<{';
                    fields.forEach(function (field, key) {
                        res_1 += '\n' + innerIndent_1 + JSON.stringify(key);
                        if (field.count === total_1) {
                            // all items has this field
                            res_1 += ':';
                        }
                        else {
                            // only some items has this field, this field is optional
                            res_1 += '?:';
                        }
                        res_1 += ' ' + Array.from(field.types).join(' | ') + ';';
                    });
                    res_1 += '\n' + currentIndent + '}>';
                    nonObjectTypes.forEach(function (type) { return (res_1 += ' | ' + type); });
                    return res_1;
                }
                var childTypes = Array.from(new Set(o.map(function (x) { return genTsType(x, nextLevelOption_1); })));
                if (childTypes.length === 1) {
                    return "Array<" + genTsType(o[0], options) + ">";
                }
                if (options.allowMultiTypedArray) {
                    return "Array<" + childTypes.join(' | ') + ">";
                }
                console.error('array of different types, childTypes:', childTypes);
                throw new Error('array of different types');
            }
            if (o instanceof Set) {
                if (o.size < 1) {
                    if (options.allowEmptyArray) {
                        return 'Set<any>';
                    }
                    throw new TypeError('cannot determine type of empty set');
                }
                return genTsType(Array.from(o), options).replace('Array', 'Set');
            }
            if (o instanceof Map) {
                if (o.size < 1) {
                    if (options.allowEmptyArray) {
                        return 'Map<any>';
                    }
                    throw new TypeError('cannot determine type of empty map');
                }
                var keyType = Array.from(new Set(Array.from(o.keys()).map(function (x) { return genTsType(x, options); }))).join(' | ');
                var valueType = Array.from(new Set(Array.from(o.values()).map(function (x) { return genTsType(x, options); }))).join(' | ');
                return "Map<" + keyType + ", " + valueType + ">";
            }
            // really object
            if (options.format) {
                var res_2 = '{';
                Object.entries(o).forEach(function (_a) {
                    var _b = __read(_a, 2), k = _b[0], v = _b[1];
                    res_2 += "\n" + innerIndent_1 + JSON.stringify(k) + ": " + genTsType(v, nextLevelOption_1) + ";";
                });
                res_2 += '\n' + currentIndent + '}';
                return res_2;
            }
            return "{ " + Object.entries(o)
                .map(function (_a) {
                var _b = __read(_a, 2), k = _b[0], v = _b[1];
                return JSON.stringify(k) + ": " + genTsType(v, options);
            })
                .join('; ') + " }";
        default:
            console.error('unknown type', { type: type, o: o });
            throw new TypeError('unknown type: ' + type);
    }
}
exports.genTsType = genTsType;
/** @deprecated will rename to genTsType in next major release */
exports.getTsType = genTsType;
//# sourceMappingURL=ts-type.js.map